<html>
<head>
<title>OgreEGLSupport.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_43d9b0265a5a2fd53bf3892a292ce5e9.html">RenderSystems</a>      </li>
      <li class="navelem"><a class="el" href="dir_9e680f2cca56003d76c91ad8153c6d1e.html">GLES</a>      </li>
      <li class="navelem"><a class="el" href="dir_2b7861191a86db021136edf07f6d3897.html">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_deb9eb5bc671f6ecaf004baa51219216.html">EGL</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">include/EGL/OgreEGLSupport.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="include_2EGL_2OgreEGLSupport_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2008 Renato Araujo Oliveira Filho &lt;renatox@gmail.com&gt;</span>
<a name="l00008"></a>00008 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00009"></a>00009 <span class="comment"></span>
<a name="l00010"></a>00010 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00011"></a>00011 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00012"></a>00012 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00013"></a>00013 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00014"></a>00014 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00015"></a>00015 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00016"></a>00016 <span class="comment"></span>
<a name="l00017"></a>00017 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00018"></a>00018 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00019"></a>00019 <span class="comment"></span>
<a name="l00020"></a>00020 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00021"></a>00021 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00022"></a>00022 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00023"></a>00023 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00024"></a>00024 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00025"></a>00025 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00026"></a>00026 <span class="comment">THE SOFTWARE.</span>
<a name="l00027"></a>00027 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00028"></a>00028 <span class="comment">*/</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="preprocessor">#ifndef __EGLSupport_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span><span class="preprocessor">#define __EGLSupport_H__</span>
<a name="l00032"></a>00032 <span class="preprocessor"></span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreGLESSupport_8h.html">OgreGLESSupport.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="OgreGLESPrerequisites_8h.html">OgreGLESPrerequisites.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="OgreGLESPBuffer_8h.html">OgreGLESPBuffer.h</a>&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;<a class="code" href="include_2EGL_2OgreEGLWindow_8h.html">OgreEGLWindow.h</a>&quot;</span>
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 <span class="keyword">namespace </span>Ogre {
<a name="l00040"></a>00040     <span class="keyword">template</span>&lt;<span class="keyword">class</span> C&gt; <span class="keywordtype">void</span> <a class="code" href="namespaceOgre.html#a78eec3072ad2dc8efe869c96f09fc5f9">removeDuplicates</a>(C&amp; c)
<a name="l00041"></a>00041     {
<a name="l00042"></a>00042         std::sort(c.begin(), c.end());
<a name="l00043"></a>00043         <span class="keyword">typename</span> C::iterator p = std::unique(c.begin(), c.end());
<a name="l00044"></a>00044         c.erase(p, c.end());
<a name="l00045"></a>00045     }
<a name="l00046"></a>00046 
<a name="l00047"></a><a class="code" href="classOgre_1_1EGLSupport.html">00047</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#af4c2f5df97e3050dd5266408be42db4b">_OgrePrivate</a> <a class="code" href="classOgre_1_1EGLSupport.html">EGLSupport</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1GLESSupport.html">GLESSupport</a>
<a name="l00048"></a>00048     {
<a name="l00049"></a>00049         <span class="keyword">protected</span>:
<a name="l00050"></a>00050             <span class="keywordtype">void</span> refreshConfig(<span class="keywordtype">void</span>);
<a name="l00051"></a>00051 
<a name="l00052"></a><a class="code" href="classOgre_1_1EGLSupport.html#aa4de9faf0f6efb4cdb1c68b25a75c74b">00052</a>             EGLDisplay <a class="code" href="classOgre_1_1EGLSupport.html#aa4de9faf0f6efb4cdb1c68b25a75c74b">mGLDisplay</a>;
<a name="l00053"></a><a class="code" href="classOgre_1_1EGLSupport.html#a4bdbc9f0107e8ee95b5dcec47216d8f3">00053</a>             NativeDisplayType <a class="code" href="classOgre_1_1EGLSupport.html#a4bdbc9f0107e8ee95b5dcec47216d8f3">mNativeDisplay</a>;
<a name="l00054"></a>00054 
<a name="l00055"></a><a class="code" href="classOgre_1_1EGLSupport.html#a808efb6a1fb19a550843ac63bf6c037e">00055</a>             <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1EGLSupport.html#a808efb6a1fb19a550843ac63bf6c037e">mIsExternalDisplay</a>;
<a name="l00056"></a><a class="code" href="classOgre_1_1EGLSupport.html#a20ac344c7cf3a06ae4c99881490fb8c0">00056</a>             <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1EGLSupport.html#a20ac344c7cf3a06ae4c99881490fb8c0">mRandr</a>;
<a name="l00057"></a><a class="code" href="classOgre_1_1EGLSupport.html#a2ab866270a4f9855f5ade44f8b89954b">00057</a>             <span class="keyword">typedef</span> std::pair&lt;uint, uint&gt; <a class="code" href="classOgre_1_1EGLSupport.html#a2ab866270a4f9855f5ade44f8b89954b">ScreenSize</a>;
<a name="l00058"></a><a class="code" href="classOgre_1_1EGLSupport.html#a2c181c1dc4c2be2959d3a0aa1d6cba41">00058</a>             <span class="keyword">typedef</span> <span class="keywordtype">short</span> <a class="code" href="classOgre_1_1EGLSupport.html#a2c181c1dc4c2be2959d3a0aa1d6cba41">Rate</a>;
<a name="l00059"></a><a class="code" href="classOgre_1_1EGLSupport.html#a3e8e4d09921cdd2feceb40d8839c4391">00059</a>             <span class="keyword">typedef</span> std::pair&lt;ScreenSize, Rate&gt; <a class="code" href="classOgre_1_1EGLSupport.html#a3e8e4d09921cdd2feceb40d8839c4391">VideoMode</a>;
<a name="l00060"></a><a class="code" href="classOgre_1_1EGLSupport.html#a3961028aebab61daa64d01e71a4457fb">00060</a>             <span class="keyword">typedef</span> std::vector&lt;VideoMode&gt; <a class="code" href="classOgre_1_1EGLSupport.html#a3961028aebab61daa64d01e71a4457fb">VideoModes</a>;
<a name="l00061"></a><a class="code" href="classOgre_1_1EGLSupport.html#af1405d57f16e7dc7aadf9c6e82a7dec6">00061</a>             <a class="code" href="classOgre_1_1EGLSupport.html#a3961028aebab61daa64d01e71a4457fb">VideoModes</a> <a class="code" href="classOgre_1_1EGLSupport.html#af1405d57f16e7dc7aadf9c6e82a7dec6">mVideoModes</a>;
<a name="l00062"></a><a class="code" href="classOgre_1_1EGLSupport.html#a7de959d87162266a6fa5e8b9f54ddfaa">00062</a>             <a class="code" href="classOgre_1_1EGLSupport.html#a3e8e4d09921cdd2feceb40d8839c4391">VideoMode</a> <a class="code" href="classOgre_1_1EGLSupport.html#a7de959d87162266a6fa5e8b9f54ddfaa">mOriginalMode</a>;
<a name="l00063"></a><a class="code" href="classOgre_1_1EGLSupport.html#ab3c0d4143d94dd3208b4b1dfc8f4ab28">00063</a>             <a class="code" href="classOgre_1_1EGLSupport.html#a3e8e4d09921cdd2feceb40d8839c4391">VideoMode</a> <a class="code" href="classOgre_1_1EGLSupport.html#ab3c0d4143d94dd3208b4b1dfc8f4ab28">mCurrentMode</a>;
<a name="l00064"></a><a class="code" href="classOgre_1_1EGLSupport.html#aa0be15e5b971b2cc46cec7e0e136b96a">00064</a>             <a class="code" href="group__General.html#ga0899c03496d3c25c6555889aa76a78db">StringVector</a> <a class="code" href="classOgre_1_1EGLSupport.html#aa0be15e5b971b2cc46cec7e0e136b96a">mSampleLevels</a>;
<a name="l00065"></a>00065 
<a name="l00066"></a>00066             <span class="comment">//virtual EGLWindow* createEGLWindow( EGLSupport * support) = 0;</span>
<a name="l00067"></a>00067         <span class="keyword">public</span>:
<a name="l00068"></a>00068             <a class="code" href="classOgre_1_1EGLSupport.html">EGLSupport</a>();
<a name="l00069"></a>00069             <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1EGLSupport.html">EGLSupport</a>();
<a name="l00070"></a>00070 
<a name="l00071"></a>00071             <span class="keywordtype">void</span> start(<span class="keywordtype">void</span>);
<a name="l00072"></a>00072             <span class="keywordtype">void</span> stop(<span class="keywordtype">void</span>);
<a name="l00073"></a>00073             <span class="keywordtype">void</span> addConfig(<span class="keywordtype">void</span>);
<a name="l00074"></a>00074             <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> validateConfig(<span class="keywordtype">void</span>);
<a name="l00075"></a>00075             <span class="keywordtype">void</span> setConfigOption(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;name, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;value);
<a name="l00076"></a>00076             <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> getDisplayName (<span class="keywordtype">void</span>);
<a name="l00077"></a>00077         EGLDisplay getGLDisplay(<span class="keywordtype">void</span>);
<a name="l00078"></a>00078             <span class="keywordtype">void</span> setGLDisplay(EGLDisplay val);
<a name="l00079"></a>00079             EGLConfig* chooseGLConfig(<span class="keyword">const</span> EGLint *attribList, EGLint *nElements);
<a name="l00080"></a>00080             EGLBoolean getGLConfigAttrib(EGLConfig fbConfig, EGLint attribute, EGLint *value);
<a name="l00081"></a>00081             <span class="keywordtype">void</span>* getProcAddress(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">Ogre::String</a>&amp; name);
<a name="l00082"></a>00082             <a class="code" href="classOgre_1_1EGLContext.html">::EGLContext</a> createNewContext(EGLDisplay eglDisplay, ::EGLConfig glconfig, ::<a class="code" href="classOgre_1_1EGLContext.html">EGLContext</a> shareList) <span class="keyword">const</span>;
<a name="l00083"></a>00083 
<a name="l00084"></a>00084             <a class="code" href="classOgre_1_1RenderWindow.html" title="Manages the target rendering window.">RenderWindow</a>* createWindow(<span class="keywordtype">bool</span> autoCreateWindow,
<a name="l00085"></a>00085                                        <a class="code" href="classOgre_1_1GLESRenderSystem.html" title="Implementation of GL as a rendering system.">GLESRenderSystem</a> *renderSystem,
<a name="l00086"></a>00086                                        <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; windowTitle);
<a name="l00087"></a>00087 
<a name="l00088"></a>00088 <span class="comment">//            RenderWindow* newWindow(const String&amp; name,</span>
<a name="l00089"></a>00089 <span class="comment">//                                    unsigned int width, unsigned int height,</span>
<a name="l00090"></a>00090 <span class="comment">//                                    bool fullScreen,</span>
<a name="l00091"></a>00091 <span class="comment">//                                    const NameValuePairList *miscParams = 0);</span>
<a name="l00092"></a>00092 
<a name="l00093"></a>00093             ::EGLConfig getGLConfigFromContext(::<a class="code" href="classOgre_1_1EGLContext.html">EGLContext</a> context);
<a name="l00094"></a>00094             ::EGLConfig getGLConfigFromDrawable(::EGLSurface drawable,
<a name="l00095"></a>00095                                                 <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> *w, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> *h);
<a name="l00096"></a>00096             ::EGLConfig selectGLConfig (<span class="keyword">const</span> EGLint* minAttribs, <span class="keyword">const</span> EGLint *maxAttribs);
<a name="l00097"></a>00097             <span class="keywordtype">void</span> switchMode(<span class="keywordtype">void</span>);
<a name="l00098"></a>00098             <span class="keyword">virtual</span> <span class="keywordtype">void</span> switchMode(<a class="code" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a>&amp; width, <a class="code" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a>&amp; height, <span class="keywordtype">short</span>&amp; frequency) = 0;
<a name="l00099"></a>00099             <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1GLESPBuffer.html">GLESPBuffer</a>* createPBuffer(<a class="code" href="group__Image.html#gac8f59c884998d9f84d9ea4c66e4c29fe" title="Pixel component format.">PixelComponentType</a> format,
<a name="l00100"></a>00100                                        <span class="keywordtype">size_t</span> width, <span class="keywordtype">size_t</span> height) = 0;
<a name="l00101"></a>00101 <span class="comment">//          NativeDisplayType getNativeDisplay();</span>
<a name="l00102"></a>00102     };
<a name="l00103"></a>00103 }
<a name="l00104"></a>00104 
<a name="l00105"></a>00105 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:50
</p>
</body>
</html>
